﻿//【登録場所】リンク
//【ラベル】はてなブックマークuser表示
//【内容】選択したURLがはてなブックマークに登録されていれば、登録ユーザー数と「ブックマークしているユーザー」を表示。1.0.6_08で動作確認。
//外部コマンド→一般→リンクに登録してリンクを右クリックから実行も可。複数リンクが対象の場合は不可。
//【コマンド1】$SCRIPT b_hatena.js
//【スクリプト】

function gethatebu(bh) {
	ss=" ";
	if (v2c.context.selText){
		ss = v2c.context.selText;
	}
	if (v2c.context.link){
		ss = v2c.context.link;
		ss=ss.toString();
	}

	if (ss) {ss = ss.trim();}
	if (!ss) {
		v2c.alert("選択テキストを取得できませんでした。");
		return;
	}
	var baseuri = "http://b.hatena.ne.jp/entry/";
	var pbaseuri = "http://b.hatena.ne.jp/";
	ss=fixuri(ss);
	ss=ss.slice(7);
	var su = baseuri+ss;
	var sh = v2c.readURL(su);
	if (!sh) {
		v2c.alert("ページを取得できませんでした。");
		return;
	}
	var title = sh.match(/<title>はてなブックマーク - 未ブックマークエントリー<\/title>/i);
	if (title) {
		v2c.alert("このページはまだブックマークされていません。");
		v2c.context.setPopupHTML('<html><head></head><body><div><a href=\"'+su+'\">はてなブックマーク - 未ブックマークエントリー</a></div></body></html>');
		return;
	}
	var mr = sh.match(/<li\sclass=\"users\">(?:<strong>|<em>|)(<a[^>]+>.+?<\/a>)/i);
	if (!mr) {
		v2c.alert("ユーザー数を抽出できませんでした。");
		v2c.context.setPopupHTML('<html><head></head><body><div><a href=\"'+su+'\">ページへのリンク</a></div></body></html>');
		return;
	}
	var numofusers = RegExp.$1;
	//ブックマークしているユーザーの抽出
	var bul=sh.match(/<ul\sid=\"bookmarked_user\"[^>]+>(?:[\s\S]*?)<script(?:[\s\S]*?)<\/script>([\s\S]*?)<\/ul>/i);
	if (!bul) {
		v2c.alert("ブックマークしているユーザーを抽出できませんでした。");
		v2c.context.setPopupHTML('<html><head></head><body><div><a href=\"'+su+'\">ページへのリンク</a></div></body></html>');
		return;
	}
	var bmuser=RegExp.$1;

	//gifを表示するとCPU利用率が100%になったままになるのでimg要素を削除
	bmuser=bmuser.replace(/<img[^>]+?>/g," ");

	if (bh) {
		v2c.context.setPopupHTML("<html><head><base href=\""+pbaseuri+"\"></head><body><div>"+numofusers+"<ul>"+bmuser+"</ul>"+"</div></body></html>");
	} else {
		v2c.context.setPopupHTML("<html><head><base href=\""+pbaseuri+"\"></head><body>"+numofusers+"</body></html>");
	}
}

function fixuri(txt){
	var ptn=/\:\/\//i;
	var idx=txt.search(ptn);
	var turi=txt.slice(idx);
	var uri="http"+turi;
	return uri;
}

/*
引数がtrueならユーザー数と「ブックマークしているユーザー」(=<ul id="bookmarked_user"から</ul>まで)も表示。
falseならユーザー数のみ。
*/
gethatebu(true);